package org.nutch.authhelp;

import java.io.UnsupportedEncodingException;
import java.util.HashMap;

import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.HttpMethod;
import org.apache.commons.httpclient.HttpStatus;
import org.apache.commons.httpclient.MultiThreadedHttpConnectionManager;
import org.apache.commons.httpclient.NameValuePair;
import org.apache.commons.httpclient.cookie.CookiePolicy;
import org.apache.commons.httpclient.methods.GetMethod;
import org.apache.commons.httpclient.methods.PostMethod;
import org.apache.commons.httpclient.protocol.Protocol;

public class LoginHelp {
	
	private static HttpClient client;
	private static FormAuthParam params;
	private static HttpMethod method;
	private static String preferencePage;
	
	public static HttpClient getLoggedInClient( String usernameParamName, String passwordParamName, String username, String password, String url, String prefPage, String className) {
		params = new FormAuthParam(
                username,
                password,
                url,
                className);
		client = getSecureClient();
		preferencePage = prefPage;
		try {
			method = createLoginHttpPost(usernameParamName, passwordParamName);
			if (!login()) {
				return null;
			}
		}
		catch (Exception e) {
			e.printStackTrace();
		}
		return client;
	}
	
	public static HttpClient getSecureClient() {
	    	MultiThreadedHttpConnectionManager connectionManager = new MultiThreadedHttpConnectionManager();
	        HttpClient client = new HttpClient(connectionManager);

	        Protocol https = new Protocol("https", new DummySSLProtocolSocketFactory(), 443);
	        Protocol.registerProtocol("https", https);

	        return client;
	}
	private static boolean login() throws UnsupportedEncodingException {
        boolean success = false;

        try {
            int statusCode = client.executeMethod(method);
            method.releaseConnection();

            method = new GetMethod(preferencePage);
            statusCode = client.executeMethod(method);

            if (statusCode != HttpStatus.SC_OK) {
                return success;
            }

            if (statusCode != HttpStatus.SC_OK) {
                return success;
            }

            String responseBody = new String(method.getResponseBody());
            if (responseBody.contains(params.username)) {
                success = true;
            }
            
        } catch (Exception e) {
            e.printStackTrace();
            return success;
        } finally {
            // Release the connection.
            method.releaseConnection();
        }

        return success;
    }
	
	private static HttpMethod createLoginHttpPost( String usr, String psw) throws UnsupportedEncodingException {
        PostMethod httpPost = new PostMethod(params.loginPage);
        NameValuePair[] nvps = new NameValuePair[]{
        		new NameValuePair(usr, params.username),
        		new NameValuePair(psw, params.password)
        };

        httpPost.setRequestBody(nvps);
        httpPost.getParams().setCookiePolicy(CookiePolicy.BROWSER_COMPATIBILITY);

        return httpPost;
    }
	
	public static HttpClient getClient() {
    	MultiThreadedHttpConnectionManager connectionManager = new MultiThreadedHttpConnectionManager();
        HttpClient client = new HttpClient(connectionManager);

        return client;
    }

}
