package org.plugin.linkedin;

import java.io.*;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Scanner;

import org.jdom2.Document;
import org.jdom2.Element;
import org.jdom2.input.SAXBuilder;
import org.plugin.startclass.*;
import org.scribe.builder.*;
import org.scribe.builder.api.*;
import org.scribe.model.*;
import org.scribe.oauth.*;
import org.oauth.scribe.*;


public class LinkedInPluginAuto extends ASearchPlugin {
	
	//other class variables
	private OAuthService service;
	private String api_key = "mo9bnbrjv1l0";
	private String key_secret = "DQgvz9TyrhFKU8Gt";
	private String tokenFileName;
	private ArrayList<HashMap<String, String>> results;
	
	@Override
	public ArrayList<HashMap<String,String>> executeQuery(HashMap<String, String> data) {
		long startT, stop, sum = 0;
		//service = ScribeHelp.getService(ScribeHelp.LINKEDIN, api_key, key_secret);
		String protectedUrl = "http://api.linkedin.com/v1/people-search:(people:(first-name,last-name,positions:(is-current,company:(name))),num-results)";

		int count = 25;
		int start = 0;
		String params = getParametersInString(data, "UTF-8");

	    Token accessToken = ScribeHelp.getAccessToken(ScribeHelp.LINKEDIN, service);
	    results = new ArrayList<HashMap<String, String>>();
		for (int total = 1; total > start;) {
			// Now let's go and ask for a protected resource!
			OAuthRequest request = new OAuthRequest(Verb.GET, protectedUrl + "?" + params + "&count=" + count + "&start=" + start /*+ "&facet=network,F,S,O"*/);
			service.signRequest(accessToken, request);
			
			startT = System.currentTimeMillis();
			Response response = request.send();
			stop = System.currentTimeMillis();
	        sum = sum + stop - startT;
	        
			start = start + 25;
			total = useDataFromResponse(response.getBody(), data);
		}
		
		System.out.println("Download time: " + sum + " ms");
		return results;
	}
	
	/*
	 * Returns the total number of hits.
	 */
	@SuppressWarnings("unchecked")
	private int useDataFromResponse(String body, HashMap<String, String> data) {
		HashMap<String, String> temp;
		int total = 0;
		SAXBuilder builder = new SAXBuilder();
		Reader in = new StringReader(body);
		Document response;
		String name, nameS;
		String surname, surnameS;
		List<Element> people;

		//Associate the name and surname with a set of companies
		try{
			response = builder.build(in);
			people = response.getRootElement().getChild("people").getChildren("person");
			total = Integer.parseInt(response.getRootElement().getChild("people").getAttributeValue("total"));
			nameS = prepareParameter(data.get("name"));
			surnameS = prepareParameter(data.get("surname"));

			for (Element person : people) {
				name = prepareParameter(person.getChildText("first-name"));
				surname = prepareParameter(person.getChildText("last-name"));
				temp = (HashMap<String,String>)data.clone();

				if ( name.contains(nameS) && surname.contains(surnameS)) {
					temp.put("name", name);
					temp.put("surname", surname);
					if (person.getChild("positions") != null) {
						List<Element> positions =  person.getChild("positions")
						.getChildren("position");
						for (Element position : positions) {
							if (position.getChildText("is-current").equalsIgnoreCase("true") && position.getChild("company").getChildText("name") != null) {
								temp = (HashMap<String, String>)temp.clone();
								temp.put("linkedin-name", position.getChild("company").getChildText("name"));
								results.add(temp);
							}
						}
					}
				}
			}
		} catch (NullPointerException npe) {
			System.out.println(body);
			npe.printStackTrace();
		} catch(Exception e) {
			e.printStackTrace();
		}
		return total;
	}

	@Override
	public Element inputXML() {
		Element result = new Element("dataItem");
		result.addContent(new Element("name"));
		result.addContent(new Element("surname"));
		
		return result;
	}


	@Override
	public Element outputXML() {
		Element result = new Element("dataItem"), companies = new Element("companies"), company = new Element("company");
		company.addContent(new Element("linkedin-name"));
		companies.setAttribute("container", "true");
		companies.addContent(company);
		result.addContent(companies);
		result.addContent(new Element("type").setText("PERSON"));
		
		return result;
	}
	@Override
	public void init() {
		service = ScribeHelp.getService(ScribeHelp.LINKEDIN, "mo9bnbrjv1l0", "DQgvz9TyrhFKU8Gt");
		inputParameters = new String[]{"name", "surname"};
		translatedParameters = new String[]{"first-name", "last-name"};
		
	}
}

