package org.plugin.simobil;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Scanner;

import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.HttpMethod;
import org.apache.commons.httpclient.MultiThreadedHttpConnectionManager;
import org.apache.commons.httpclient.NameValuePair;
import org.apache.commons.httpclient.methods.GetMethod;
import org.apache.commons.httpclient.util.EncodingUtil;
import org.jdom2.Document;
import org.jdom2.Element;
import org.jsoup.Jsoup;
import org.jsoup.select.Elements;
import org.nutch.authhelp.FormAuthParam;
import org.plugin.startclass.*;

public class SimobilPluginAuto extends ASearchPlugin {

	protected HttpClient client;
	protected FormAuthParam params;
	private static final String preferencePage = "http://www.simobil.si/sl/phoneBook.cp2";
	private ArrayList<HashMap<String,String>> resultList = new ArrayList<HashMap<String,String>>();
	
	@Override
	public ArrayList<HashMap<String,String>> executeQuery(HashMap<String, String> data) {
		long  start, stop, sum = 0;
		String name, surname, paramsQueryString;
		HttpMethod method;
		boolean anotherPage;
		int pageNum;
		resultList = new ArrayList<HashMap<String, String>>();
		
		name = prepareParameter(data.get("name"));
		surname = prepareParameter(data.get("surname"));
		pageNum = 1;

    	paramsQueryString = getCodedString("keywords", name + " " + surname , "UTF-8");
    	paramsQueryString = paramsQueryString + "&cid=null&linkid=basicPhoneBook&submitted=phoneBook&query=basic&additional=&page=";
        
		method = new GetMethod(preferencePage);
		anotherPage = true;
		while (anotherPage) {
			anotherPage = false;
			method.setQueryString(paramsQueryString + pageNum);
			pageNum = pageNum + 1;
			try {
				start = System.currentTimeMillis();
				client.executeMethod(method);
				stop = System.currentTimeMillis();
		        sum = sum + stop - start;
		        
				anotherPage = useData(convertStreamToString(method.getResponseBodyAsStream()), data);
				//if (anotherPage)
				Thread.sleep(sleepTime);
				System.out.println("+ 0,5 s waiting");
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		System.out.println("Download time: " + sum + " ms");
		return resultList;
	}

	private String convertStreamToString(java.io.InputStream is) {
	    try {
	        return new java.util.Scanner(is, "UTF-8").useDelimiter("\\A").next();
	    } catch (java.util.NoSuchElementException e) {
	        return "";
	    }
	}

	private boolean useData (String body, HashMap<String, String> data) {
		org.jsoup.nodes.Document page =  Jsoup.parse(body);
		org.jsoup.nodes.Element results = page.getElementById("phonebook-results");
		String  textContact, nameSurname, address, number, name, surname = "";
		Elements contacts = results.getElementsByTag("li");
		Scanner scanContact;
		HashMap<String, String> temp;
		if (contacts.size() == 0) {
			return false;
		}
		
		for (org.jsoup.nodes.Element contact : contacts) {
			textContact = contact.html();

			temp = (HashMap<String, String>)data.clone();
			scanContact = new Scanner(textContact);
			scanContact.useDelimiter("<br />");
			nameSurname = scanContact.next().replaceAll("<.*?>", "").replaceFirst("^.*?\\.", "").trim().replaceAll("\\s+", " ");
			address = scanContact.next().replaceAll("<.*?>", "");
			address = address + ", " + scanContact.next().replaceAll("<.*?>", "");
			number = "0" + scanContact.next().replaceAll("<.*?>", "").trim();
			address = prepareParameter(address).trim().replaceAll("\\s+", " ");
				
			scanContact = new Scanner(nameSurname);
			name = prepareParameter(scanContact.next());
			surname = "";
			while (scanContact.hasNext()) {
				surname = (surname + " " + scanContact.next()).trim();
			}
			surname = prepareParameter(surname);
			// Don't use contacts that have S.P. at the end! - Those are not persons.
			if ( (name.contains(data.get("name")) || surname.contains(data.get("surname"))) && !surname.contains("S.P.")) {
				temp.put("name", name);
				temp.put("surname", surname);
				temp.put("address", address);
				temp.put("operator", "SIMOBIL");
				temp.put("number", number);
				resultList.add(temp);
			}			
		}
		
		return true;
	}

	@Override
	public Element inputXML() {
		Element result = new Element("dataItem");
		result.addContent(new Element("name"));
		result.addContent(new Element("surname"));
		
		return result;
	}

	@Override
	public Element outputXML() {
		Element result = new Element("dataItem"), contacts = new Element("contacts"), 
				contact = new Element("contact"), phones = new Element("phones"), phone = new Element("phone");
		contacts.setAttribute("container", "true");
		phones.setAttribute("container", "true");
		contact.addContent(new Element("address"));
		phone.addContent(new Element("operator"));
		phone.addContent(new Element("number"));
		result.addContent(new Element("type").setText("PERSON"));
		result.addContent(contacts.addContent(contact.addContent(phones.addContent(phone))));
		
		return result;
	}

	@Override
	public void init() {
		client = org.nutch.authhelp.LoginHelp.getClient();
	}

}
