package org.plugin.startclass;

import java.io.File;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import org.apache.commons.httpclient.NameValuePair;
import org.apache.commons.httpclient.util.EncodingUtil;
import org.jdom2.Document;
import org.jdom2.Element;
import org.jdom2.input.SAXBuilder;

public abstract class ASearchPlugin implements SearchPlugin {
	
	protected String[] inputParameters;
	protected String[] translatedParameters;
	
	public abstract void init();
	public abstract ArrayList<HashMap<String,String>> executeQuery(HashMap<String,String> data);
	
	@Override
	public ArrayList<HashMap<String, String>> makeQuery(ArrayList<HashMap<String, String>> data) {
		HashMap<String, String> dataItem;
		ArrayList<HashMap<String, String>> returnData = new ArrayList<HashMap<String, String>>(), tempList;
		for (int i = 0; i < data.size(); i++) {
			dataItem = data.get(i);
			tempList = executeQuery(dataItem);
			if (tempList != null)
				returnData.addAll(tempList);
		}
		return returnData;
	}
	
	protected HashMap<String, String> getLoginData(String pluginName) {
		SAXBuilder sb = new SAXBuilder();
		HashMap<String, String> data = new HashMap<String, String>();
		try {
			Document loginData = sb.build(new File("loginData.xml"));
			Element plugin = loginData.getRootElement().getChild(pluginName);
			for (Element child : plugin.getChildren()) {
				data.put(child.getName(), child.getTextTrim());
			}
		}
		catch (NullPointerException npe) {
			System.out.println("Some login data probably missing");
			return null;
		}
		catch (Exception e) {
			e.printStackTrace();
		}
		
		return data;
	}
	
	protected String getParametersInString(HashMap<String,String> data, String coding) {
		NameValuePair[] params = new NameValuePair[inputParameters.length];
		
		for (int i = 0; i < inputParameters.length; i++) {
			params[i] = new NameValuePair(translatedParameters[i], prepareParameter(data.get(inputParameters[i])));
		}
		
		return EncodingUtil.formUrlEncode(params, coding);
	}
	
	protected String prepareParameter(String parameter) {
		if (parameter == null) {
			parameter = "";
		}
		return parameter.toUpperCase();
	}
	protected String getCodedString (String paramName, String value, String coding) {
		NameValuePair[] nvp = new NameValuePair[]{
				new NameValuePair(paramName, value)
		};
		return EncodingUtil.formUrlEncode(nvp, coding);
	}
	public ASearchPlugin () {
		init();
	}
}
