package org.plugin.ajpes;

import org.apache.commons.httpclient.*;
import org.apache.commons.httpclient.cookie.CookiePolicy;
import org.apache.commons.httpclient.methods.GetMethod;
import org.apache.commons.httpclient.methods.PostMethod;
import org.apache.commons.httpclient.methods.PutMethod;
import org.apache.commons.httpclient.params.HttpConnectionManagerParams;
import org.apache.commons.httpclient.protocol.Protocol;
import org.apache.commons.httpclient.util.EncodingUtil;
import org.nutch.authhelp.*;
import org.plugin.startclass.*;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;

/*
import org.apache.nutch.protocol.httpclient.DummySSLProtocolSocketFactory;
*/

import java.io.UnsupportedEncodingException;

public class AjpesPluginAuto extends ASearchPlugin{
	
	//other class variables
	protected HttpClient client;
	protected FormAuthParam params;
	private static final String preferencePage = "https://www.ajpes.si/prs/";
	private HashMap<String, String> loginData;
	private long start, stop, sum = 0;

	@Override
	public ArrayList<HashMap<String,String>> executeQuery(HashMap<String, String> data) {
		ArrayList<HashMap<String, String>> returnList = new ArrayList<HashMap<String, String>>();
		int statusCode;
    	int mode = 0;
    	String baseUri = "https://www.ajpes.si/prs/";
    	String companyName = data.get("linkedin-name");
    	String username = loginData.get("uporabnik");
    	
    	
    	//client = org.nutch.authhelp.LoginHelp.getLoggedInClient("uporabnik", "geslo", username, loginData.get("geslo"), "https://www.ajpes.si/login/checkuser.asp", preferencePage, "AjpesPlugin");
    	String paramString = getCodedString("naziv", data.get("linkedin-name").replaceAll(",.*",""), "windows-1252");
    	paramString = paramString + "&MAXREC=100&status=1";
    	
    	
        HttpMethod method = new PostMethod(baseUri + "/rezultati.asp");
        method.setQueryString(paramString);
        
        try {
        	start = System.currentTimeMillis();
	        statusCode = client.executeMethod(method);
	        stop = System.currentTimeMillis();
	        sum = sum + stop - start;
	        if (statusCode != HttpStatus.SC_OK) {
	        	System.out.println("AjpesPlugin:Napaka v poizvedbi");
	        }
	
	        String responseBody = new String(method.getResponseBody());
	        if (responseBody.contains(username)) {
	        	Document results = Jsoup.parse(responseBody, baseUri);
	            Elements links = results.getElementsByTag("a");
	            boolean foundMatch = false;
	            Element link;
	            for (int j = 0; j < links.size() && !foundMatch; j++) {
	            	link = links.get(j);
	            	if (link.attr("abs:href").startsWith("https://www.ajpes.si/prs/podjetje.asp?") /*&& companyName.toUpperCase().startsWith(link.text().substring(0, 1).toUpperCase())*/) {
	            		Thread.sleep(sleepTime);
	            		System.out.println("+ 0,5 s waiting");
	            		method.releaseConnection();
	            		mode = 0;
		            	method = new PostMethod(link.attr("abs:href"));
		            	
		            	start = System.currentTimeMillis();
		            	statusCode = client.executeMethod(method);
		            	stop = System.currentTimeMillis();
		    	        sum = sum + stop - start;
		
		            	// Redirection.
		                if (statusCode != HttpStatus.SC_OK) {
		                    String redirectLocation = "";
		                    if (statusCode == HttpStatus.SC_MOVED_PERMANENTLY || statusCode == HttpStatus.SC_MOVED_TEMPORARILY) {
		                        mode = 1;
		                        Thread.sleep(sleepTime);
		                        System.out.println("+ 0,5 s waiting");
		                        
		                        Header locationHeader = method.getResponseHeader("location");
		                        if (locationHeader != null) {
		                        	redirectLocation = locationHeader.getValue();
		                            redirectLocation = baseUri + redirectLocation;
		                        }
		                            
		                        method.releaseConnection();
		                        method = new PostMethod(redirectLocation);
		                        start = System.currentTimeMillis();
		                        statusCode = client.executeMethod(method);
		                        stop = System.currentTimeMillis();
		            	        sum = sum + stop - start;
		                    }
		                }
		
		                    
		                responseBody = new String(method.getResponseBody());
		                // We've got the results for the query
		                if (responseBody.contains(username)) {
		                    if (responseBody.contains("CAPTCHA")) {
		                    	System.out.println("Bot detected.");
		                    }
		                    
		                    // Retrieve data from page
		                    Document infoPage = Jsoup.parse(responseBody);
		                    Elements dataTabs;
		                    Element tab;
		                    String officalName = "", longName = "", shortName = "", address = "", registrationNumber = "", street = "", town = "";
		                    
		                    if (mode == 0) {
		                    	dataTabs = infoPage.getElementsByClass("tabData");
		                    	for (int i = 0; i < dataTabs.size(); i++) {
		                    		tab = dataTabs.get(i);
		                    		if (tab.text().startsWith("popolno ime:")) {
		                    			longName = dataTabs.get(i+1).text();
		                    		} 
		                    		else if (tab.text().startsWith("ulica:")) {
		                    			street = dataTabs.get(i+1).text();
		                    		} 
		                    		else if (tab.text().startsWith("pota:")) {
		                    			town = dataTabs.get(i+1).text();
		                    		} 
		                    		else if (tab.text().startsWith("kratko ime:")) {
		                    			shortName = dataTabs.get(i+1).text();
		                    		} 
		                    		else if (tab.text().startsWith("matina tevilka:")) {
		                    			registrationNumber = dataTabs.get(i+1).text();
		                    		}
		                    	}
		                    	address = street + ", " + town;
		                    }
		                    else if (mode == 1) {
		                    	dataTabs = infoPage.getElementsByTag("td");
		                    	for (int i = 0; i < dataTabs.size(); i++) {
		                    		tab = dataTabs.get(i);
		                    		if (tab.text().startsWith("firma:")) {
		                    			longName = dataTabs.get(i+1).text().toUpperCase();
		                    		} 
		                    		else if (tab.text().startsWith("poslovni naslov:")) {
		                    			address = dataTabs.get(i+1).text().toUpperCase();
		                    		} 
		                    		else if (tab.text().startsWith("skrajana firma:")) {
		                    			shortName = dataTabs.get(i+1).text().toUpperCase();
		                    		} 
		                    		else if (tab.text().startsWith("matina tevilka:")) {
		                    			registrationNumber = dataTabs.get(i+1).text();
		                    		}
		                    	}
		                    }
	
		                   	
		                   	officalName = (namesMatch(data.get("linkedin-name"), shortName)) ? shortName : longName;
		                   	
		                   	if ( shortName.equals(officalName) || namesMatch(data.get("linkedin-name"), officalName/*, person.getChildText("name"), person.getChildText("surname")*/)) {
		                   		foundMatch = true;
		                   		HashMap<String,String> temp = (HashMap<String, String>)data.clone();
		                   		temp.put("offical-name", officalName);
		                   		temp.put("company-address", address);
		                   		temp.put("registration-number", registrationNumber);
		                  
		                   		returnList.add(temp);
		                   	}
		                }
		                method.releaseConnection();
	            	}	
	            }
	        }
        }
        catch (Exception e) {
        	e.printStackTrace();
        }
        System.out.println("Downloading time: " + sum + " ms");
		return returnList;
	}
    
    private boolean namesMatch(String linkedInName, String ajpesName/*, String name, String surname*/) {
    	ajpesName = ajpesName.replaceAll(",.*","").trim().toUpperCase();
    	linkedInName = linkedInName.replaceAll(",.*","").trim();
    	if (ajpesName.contains(" S.P.")) {
    		ajpesName = ajpesName.replaceAll("S\\.P\\..*","").trim();
    	}
    	else if (ajpesName.contains(" D.O.O."))
    		ajpesName = ajpesName.replaceAll("D\\.O\\.O\\..*","").trim();
    	else if (ajpesName.contains(" D.D."))
    		ajpesName = ajpesName.replaceAll("D\\.D\\..*","").trim();

    	if (linkedInName.contains(" S.P."))
    		linkedInName = linkedInName.replaceAll("S\\.P\\..*","").trim();
    	else if (linkedInName.contains(" D.O.O."))
    		linkedInName = linkedInName.replaceAll("D\\.O\\.O\\..*","").trim();
    	else if (linkedInName.contains(" D.D."))
    		linkedInName = linkedInName.replaceAll("D\\.D\\..*","").trim();
    	
    	 return linkedInName.equals(ajpesName);
    }

	@Override
	public org.jdom2.Element inputXML() {
		org.jdom2.Element result = new org.jdom2.Element("dataItem");
		result.addContent(new org.jdom2.Element("companies").addContent(new org.jdom2.Element("company").addContent(new org.jdom2.Element("linkedin-name"))));
		
		return result;
		
	}

	@Override
	public org.jdom2.Element outputXML() {
		org.jdom2.Element result = new org.jdom2.Element("dataItem"), company = new org.jdom2.Element("company"), companies = new org.jdom2.Element("companies");
		companies.setAttribute("container", "true");
		company.addContent(new org.jdom2.Element("offical-name"));
		company.addContent(new org.jdom2.Element("company-address"));
		company.addContent(new org.jdom2.Element("registration-number"));
		result.addContent(companies.addContent(company));
		
		return result;
	}

	@Override
	public void init() {
		inputParameters = new String[]{"linkedin-name"};
		translatedParameters = new String[]{"naziv"};
		loginData = getLoginData("ajpes");
		client = org.nutch.authhelp.LoginHelp.getLoggedInClient("uporabnik", "geslo", loginData.get("uporabnik"), loginData.get("geslo"), "https://www.ajpes.si/login/checkuser.asp", preferencePage, "AjpesPlugin");
		
	}
}